#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

typedef struct tagVAR {
	char	*var_name;
	unsigned long	*pvar_value;
	int	var_defined;
} VAR;


unsigned long	ADDR_DiscardINITSection_hook_point;
unsigned long	ADDR_DiscardINITSection_hook_continue;
unsigned long	ADDR_DiskCreate__getsize_hook_point;
unsigned long	ADDR_DiskCreate__getsize_hook_continue;
unsigned long	ADDR_DiskCreate__finalize_hook_point;
unsigned long	ADDR_DiskCreate__finalize_hook_continue;
unsigned long	ADDR_PartitionCreate_hook_point;
unsigned long	ADDR_PartitionCreate_hook_continue;
unsigned long	ADDR_PartitionCreate_hook_continue_err;
unsigned long	ADDR_IDESetupReadWrite_hook_point;
unsigned long	ADDR_IDESetupReadWrite_hook_continue;
unsigned long	ADDR_IDESetupVerify_hook_point;
unsigned long	ADDR_IDESetupVerify_hook_continue;
unsigned long	VARADDR_TotalHardDriveSectors;
unsigned long	FUNCADDR_DoDiscardINITSection;
unsigned long	FUNCADDR_IncrementBootCounter;
unsigned long	FUNCADDR_RtlInitAnsiString;
unsigned long	FUNCADDR_NtOpenFile;
unsigned long	FUNCADDR_NtReadFile;
unsigned long	FUNCADDR_NtClose;
unsigned long	LOWCODE_BASE;
unsigned long	HIGHCODE_BASE;
unsigned long	PATCHSEG_SIZE;
unsigned long	ADDR_DiskIoControl_hook_point;
unsigned long	ADDR_DiskIoControl__unknown_ioctl_code;
unsigned long	ADDR_DiskIoControl__do_start_io;
unsigned long	ADDR_DiskIoControl__get_drive_geometry;
unsigned long	ADDR_DiskIoControl__do_verify;
unsigned long	ADDR_DiskIoControl__get_partition_info;
unsigned long	ADDR_DiskIoControl__return;


VAR Vars[] = {
	{ "ADDR_DiscardINITSection_hook_point", &ADDR_DiscardINITSection_hook_point },
	{ "ADDR_DiscardINITSection_hook_continue", &ADDR_DiscardINITSection_hook_continue },
	{ "ADDR_DiskCreate__getsize_hook_point", &ADDR_DiskCreate__getsize_hook_point },
	{ "ADDR_DiskCreate__getsize_hook_continue", &ADDR_DiskCreate__getsize_hook_continue },
	{ "ADDR_DiskCreate__finalize_hook_point", &ADDR_DiskCreate__finalize_hook_point },
	{ "ADDR_DiskCreate__finalize_hook_continue", &ADDR_DiskCreate__finalize_hook_continue },
	{ "ADDR_PartitionCreate_hook_point", &ADDR_PartitionCreate_hook_point },
	{ "ADDR_PartitionCreate_hook_continue", &ADDR_PartitionCreate_hook_continue },
	{ "ADDR_PartitionCreate_hook_continue_err", &ADDR_PartitionCreate_hook_continue_err },
	{ "ADDR_IDESetupReadWrite_hook_point", &ADDR_IDESetupReadWrite_hook_point },
	{ "ADDR_IDESetupReadWrite_hook_continue", &ADDR_IDESetupReadWrite_hook_continue },
	{ "ADDR_IDESetupVerify_hook_point", &ADDR_IDESetupVerify_hook_point },
	{ "ADDR_IDESetupVerify_hook_continue", &ADDR_IDESetupVerify_hook_continue },
	{ "VARADDR_TotalHardDriveSectors", &VARADDR_TotalHardDriveSectors },
	{ "FUNCADDR_DoDiscardINITSection", &FUNCADDR_DoDiscardINITSection },
	{ "FUNCADDR_IncrementBootCounter", &FUNCADDR_IncrementBootCounter },
	{ "FUNCADDR_RtlInitAnsiString", &FUNCADDR_RtlInitAnsiString },
	{ "FUNCADDR_NtOpenFile", &FUNCADDR_NtOpenFile },
	{ "FUNCADDR_NtReadFile", &FUNCADDR_NtReadFile },
	{ "FUNCADDR_NtClose", &FUNCADDR_NtClose },
	{ "LOWCODE_BASE", &LOWCODE_BASE },
	{ "HIGHCODE_BASE", &HIGHCODE_BASE },
	{ "PATCHSEG_SIZE", &PATCHSEG_SIZE },
	{ "ADDR_DiskIoControl_hook_point", &ADDR_DiskIoControl_hook_point },
	{ "ADDR_DiskIoControl__unknown_ioctl_code", &ADDR_DiskIoControl__unknown_ioctl_code },
	{ "ADDR_DiskIoControl__do_start_io", &ADDR_DiskIoControl__do_start_io },
	{ "ADDR_DiskIoControl__get_drive_geometry", &ADDR_DiskIoControl__get_drive_geometry },
	{ "ADDR_DiskIoControl__do_verify", &ADDR_DiskIoControl__do_verify },
	{ "ADDR_DiskIoControl__get_partition_info", &ADDR_DiskIoControl__get_partition_info },
	{ "ADDR_DiskIoControl__return", &ADDR_DiskIoControl__return },

};
int Num_vars = sizeof(Vars) / sizeof(Vars[0]);


void
add_var(char *var_name, unsigned long value)
{
	int	i;

	for (i = 0; i < Num_vars; i++) {
		if (strcmp(Vars[i].var_name, var_name)) {
			continue;
		}
		if (Vars[i].var_defined) {
			fprintf(stderr, "Redefining var '%s' to 0x%x\n", var_name, value);
		} else {
			//fprintf(stderr, "Defining var '%s' to 0x%x\n", var_name, value);
		}
		*(Vars[i].pvar_value) = value;
		Vars[i].var_defined = 1;
		return;
	}
//	fprintf(stderr, "Unknown variable name: '%s'\n", var_name);
}

void
verify_vars_defined(void)
{
	int	i;
	int	error = 0;

	for (i = 0; i < Num_vars; i++) {
		if (!Vars[i].var_defined) {
			fprintf(stderr, "Variable: '%s' not defined!\n", Vars[i].var_name);
			error = 1;
		}
	}
	if (error) {
		exit(1);
	}
}

void
read_var_file(char *fname)
{
	FILE	*fh;
	char	line[BUFSIZ+1];
	char	*p;
	char	*var_name;
	unsigned long	value;

	if (!(fh = fopen(fname, "rb"))) {

		fprintf(stderr, "Couldn't open file: '%s'\n!", fname);
		exit(1);
	}

	while(fgets(line, sizeof(line)-1, fh)) {
		if ((p = strchr(line, '\r'))) {
			*p = 0;
		}
		if ((p = strchr(line, '\n'))) {
			*p = 0;
		}
		if ((p = strchr(line, ';'))) {
			*p = 0;
		}
		p = strchr(line, '\0');
		while(p > line) {
			if (isspace(p[-1])) {
				*--p = 0;
			} else {
				break;
			}
		}
		p = line;
		while(*p) {
			while(*p && !isspace(*p)) {
				++p;
			}
			if (*p && isspace(*p)) {
				*p++ = ' ';
				while(*p && isspace(*p)) {
					strcpy(p, p+1);
				}
			}
		}
		if (!line[0]) {
			continue;
		}
		var_name = line;
		if (!(p = strchr(line, ' '))) {
			continue;
		}
		*p++ = 0;
		if (strncmp(p, "equ ", 4)) {
			continue;
		}
		p += 4;
		value = strtoul(p, NULL, 0);
		add_var(var_name, value);
	}
	fclose(fh);
}


out_4byte_value(unsigned long value)
{
	printf("0x%2.2X 0x%2.2X 0x%2.2X 0x%2.2X ",
		(value & 0xff),
		((value >> 8) & 0xff),
		((value >> 16) & 0xff),
		((value >> 24) & 0xff));
}


unsigned long
address_to_offset(unsigned long address)
{
	return (address - 0x80010000);
}

out_jump_patch(char *ident, unsigned long pc, unsigned long target)
{
	printf("\n\nrem #\nrem # %s\nrem #\n", ident);
	printf("..\\bin\\poke xboxkrnl.img 0x%8.8x 0xE9 ", address_to_offset(pc));
	out_4byte_value(target - (pc+5));
	printf("\n\n");
}

out_highlow_jump_patch(char *ident, unsigned long pc, unsigned long target_high)
{
	printf("\n\nrem #\nrem # %s\nrem #\n", ident);
	printf("..\\bin\\poke xboxkrnl.img 0x%8.8x 0x81 0x3D ", address_to_offset(pc));
	out_4byte_value(LOWCODE_BASE);
	out_4byte_value(0xcafebabe);
	printf("0x74 0x05\n");

	pc += 12;
	printf("..\\bin\\poke xboxkrnl.img 0x%8.8x 0xE9 ", address_to_offset(pc));
	out_4byte_value(target_high - (pc+5));
	pc += 5;
	printf("0xE9 ");
	out_4byte_value((target_high-(HIGHCODE_BASE-LOWCODE_BASE)) - (pc+5));
	printf("\n\n");
}
void
write_patch_script(void)
{
	printf("@echo off\n\n");
	printf("if exist xboxkrnl.img del xboxkrnl.img\n");
	printf("if exist xboxkrnl.tmp del xboxkrnl.tmp\n");
	printf("if exist patchseg.inc del patchseg.inc\n\n");
	printf("..\\bin\\xkresize 0x8000 xboxkrnl.orig xboxkrnl.tmp > patchseg.tmp\n");
	printf("if errorlevel 1 goto err\n");
	printf("ren xboxkrnl.tmp xboxkrnl.img\n");
	printf("ren patchseg.tmp patchseg.inc\n\n");

	printf("if exist patch.bin del patch.bin\n");
	printf("if exist patch.tmp del patch.tmp\n\n");
	printf("..\\bin\\nasm -f bin -o patch.tmp ..\\source\\patch.asm\n");
	printf("if errorlevel 1 goto err\n");
	printf("ren patch.tmp patch.bin\n\n");

	out_jump_patch("Discard INIT section hook", ADDR_DiscardINITSection_hook_point, (HIGHCODE_BASE + 0x40));
	out_highlow_jump_patch("IDE start verify hook", ADDR_IDESetupVerify_hook_point, (HIGHCODE_BASE + 0x54));
	out_highlow_jump_patch("IDE start read/write hook", ADDR_IDESetupReadWrite_hook_point, (HIGHCODE_BASE + 0x4f));
	out_highlow_jump_patch("Disk partition create hook", ADDR_PartitionCreate_hook_point, (HIGHCODE_BASE + 0x4a));
	out_jump_patch("Disk create get size hook", ADDR_DiskCreate__getsize_hook_point, (HIGHCODE_BASE + 0x45));
	out_jump_patch("Disk create finalize hook", ADDR_DiskCreate__finalize_hook_point, (HIGHCODE_BASE + 0x59));
	out_highlow_jump_patch("Disk IOCTL hook", ADDR_DiskIoControl_hook_point, (HIGHCODE_BASE + 0x5e));

	printf("\n\nrem #\nrem # %s\nrem #\n", "Now, drop the patch file into the HIGHCODE spot");
	printf("..\\bin\\poke xboxkrnl.img 0x%8.8x @patch.bin\n", address_to_offset(HIGHCODE_BASE));

	printf("\ngoto done\n");
	printf(":err\n");
	printf("@echo Error(s) encountered!\n");
	printf(":done\n");
}

int
main(int argc, char *argv[])
{

	if (argc != 3) {
		fprintf(stderr, "Usage: %s kerneldefs.inc patchseg.inc\n", argv[0]);
		exit(1);
	}
	read_var_file(argv[1]);
	read_var_file(argv[2]);
	verify_vars_defined();
	write_patch_script();
	return 0;
}

