#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int
main(int argc, char *argv[])
{
	FILE	*fh;
	unsigned long	filesize, offset;
	unsigned int	val;
//	unsigned int oldval;
	int	idx;
	int	poke_from_file = 0;
	unsigned long	from_file_size;
	FILE	*fh_from;
	unsigned long	bytes_to_poke;

	if (argc < 4) {
		fprintf(stderr, "%s file offset val [val...]\n", argv[0]);
		exit(1);
	}

	if (!(fh = fopen(argv[1], "r+b"))) {
		fprintf(stderr, "Cannot open file: '%s'!\n", argv[1]);
	}
	fseek(fh, 0L, SEEK_END);
	filesize = ftell(fh);
	fseek(fh, 0L, SEEK_SET);

	offset = strtoul(argv[2], 0, 0);

	if (argv[3][0] == '@') {
		poke_from_file = 1;
		if (!(fh_from = fopen(argv[3]+1, "rb"))) {
			fprintf(stderr, "Cannot open file @file: '%s'!\n", argv[3]+1);
			fclose(fh);
			exit(1);
		}
		fseek(fh_from, 0L, SEEK_END);
		from_file_size = ftell(fh_from);
		fseek(fh_from, 0L, SEEK_SET);
		bytes_to_poke = from_file_size;
	} else {
		bytes_to_poke = (argc - 3);
		idx = 3;
	}

	if ((offset + bytes_to_poke) > filesize) {
		fprintf(stderr, "Offset too large for file!\n");
		fclose(fh);
		exit(1);
	}
	fseek(fh, offset, SEEK_SET);
	while(bytes_to_poke--) {
		if (poke_from_file) {
			val = fgetc(fh_from);
		} else {
			val = strtoul(argv[idx], 0, 0);
		}
//		fseek(fh, offset, SEEK_SET);
//		oldval = fgetc(fh);
//printf("Poke file '%s', offset: $%lx, oldval: $%x, newval: $%x\n", argv[1], offset, oldval, val);
		if (val > 255) {
			fprintf(stderr, "Value ($%x) larger than byte value!\n", val);
			exit(1);
		}
//		fseek(fh, offset, SEEK_SET);
		fputc(val, fh);
		++offset;
		++idx;
	}
	if (poke_from_file) {
		fclose(fh_from);
	}
	fclose(fh);
	return 0;
}
